VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6570
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9270
   LinkTopic       =   "Form1"
   ScaleHeight     =   6570
   ScaleWidth      =   9270
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   3615
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   6
      Text            =   "Form1.frx":0000
      Top             =   2640
      Width           =   4695
   End
   Begin VB.ListBox List1 
      Height          =   6300
      Left            =   4920
      TabIndex        =   5
      Top             =   120
      Width           =   4215
   End
   Begin VB.CommandButton goBTN 
      Caption         =   "GO "
      Height          =   375
      Left            =   1440
      TabIndex        =   4
      Top             =   1800
      Width           =   1335
   End
   Begin VB.CommandButton FileBTN 
      Caption         =   "Choose file"
      Height          =   375
      Left            =   1440
      TabIndex        =   3
      Top             =   1200
      Width           =   1335
   End
   Begin VB.TextBox clockTXT 
      Height          =   375
      Left            =   1800
      TabIndex        =   1
      Text            =   "1000"
      Top             =   120
      Width           =   1455
   End
   Begin VB.Label Label2 
      Caption         =   "Hz"
      Height          =   255
      Left            =   3360
      TabIndex        =   2
      Top             =   240
      Width           =   375
   End
   Begin VB.Label Label1 
      Caption         =   "Clock Rate"
      Height          =   255
      Left            =   600
      TabIndex        =   0
      Top             =   240
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim ClockRate As Double
Dim FName As String
Dim DeviceIndex As Long



Private Sub clockTXT_Change()
    ClockRate = clockTXT.Text
End Sub

Private Sub FileBTN_Click()
    Dim NewFName As String

    NewFName = SelectFileOpenDialog

    If NewFName <> "" Then
        FName = NewFName
        goBTN.Enabled = True
        List1.AddItem FName
    End If
End Sub

Private Sub Form_Load()
    Dim NameSize As Long, PID As Long, Status As Long
    Dim NameStr As String

    DeviceIndex = diOnly

    Status = QueryDeviceInfo(DeviceIndex, PID, NameSize, NameStr, 0, 0)
    If (Status <> 0) Or Not ((PID = &H4002&) Or (PID = &H4003&)) Then
        DetectForm.Show vbModal, Me
        If DetectForm.DetectOK Then
            DeviceIndex = DetectForm.DeviceIndex
            Unload DetectForm
            QueryDeviceInfo DeviceIndex, PID, NameSize, NameStr, 0, 0
        Else
            Unload DetectForm
            Unload Me
            Exit Sub
        End If
    End If
End Sub

Private Sub goBTN_Click()
    Dim Count As Integer
    Dim FrameData(0 To 4096& * 8 - 1) As Integer
    Dim FramePoints As Long
    Dim Index As Integer
    Dim currentVal As Integer
    Dim loopfile As Boolean
    Dim Status As Long
    Dim Clock As Double

    FramePoints = 0
    Clock = clockTXT.Text

    Open FName For Input As #1

    Do Until EOF(1) Or (FramePoints >= 4096)
        For Count = 0 To 7
            Input #1, FrameData(FramePoints * 8 + Count)
        Next Count
        FrameData(FramePoints * 8 + 7) = FrameData(FramePoints * 8 + 7) Or &H2000&
        FramePoints = FramePoints + 1

        DoEvents
    Loop

    Close #1

    DACOutputProcess DeviceIndex, Clock, FramePoints * 8, FrameData(0)
End Sub
